# Contributing

First off, thanks for taking the time to contribute! 🌟🥳

When contributing to this repository, please first discuss the change you wish to make via issue,
email, or any other method with the owners of this repository before making a change.

Please note we have a code of conduct, please follow it in all your interactions with the project.

## Best practices

- Write clear and meaningful git commit messages.
- If the PR will *completely* fix a specific issue, include `fixes #123` in the PR body (where 123 is the specific issue number the PR will fix. This will automatically close the issue when the PR is merged.
- Make sure you don't include `@mentions` or `fixes` keywords in your git commit messages. These should be included in the PR body instead.
- When you make a PR for small change (such as fixing a typo, style change, or grammar fix), please squash your commits so that we can maintain a cleaner git history.
- Make sure you include a clear and detailed PR description explaining the reasons for the changes, and ensuring there is sufficient information for the reviewer to understand your PR.
- Additional Readings:
   - [chris.beams.io/posts/git-commit/](https://chris.beams.io/posts/git-commit/)
   - [github.com/blog/1506-closing-issues-via-pull-requests ](https://github.com/blog/1506-closing-issues-via-pull-requests)
   - [davidwalsh.name/squash-commits-git ](https://davidwalsh.name/squash-commits-git)
   - [https://mtlynch.io/code-review-love/](https://mtlynch.io/code-review-love/)

## Code of Conduct

Examples of behavior that contributes to creating a positive environment
include:

* Using welcoming and inclusive language
* Being respectful of differing viewpoints and experiences
* Gracefully accepting constructive criticism
* Focusing on what is best for the project

Things to keep in mind before creating a new commit:

* Go through the project code conventions.
* Commit [guidelines](https://www.conventionalcommits.org/en/v1.0.0/)
* [CNCF Code of Conduct](https://github.com/cncf/foundation/blob/master/code-of-conduct.md)
